package com.usky.dxtop.controller.web;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.dxtop.common.core.domain.AjaxResult;
import com.usky.dxtop.common.utils.http.HttpUtils;
import com.usky.dxtop.model.Order;
import com.usky.dxtop.service.OrderService;
import com.usky.dxtop.service.api.TopApi;
import com.usky.dxtop.service.config.RabbitmqConfig;
import com.usky.dxtop.service.emun.OrderPayType;
import com.usky.dxtop.service.emun.OrderStatus;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.apache.logging.log4j.core.util.JsonUtils;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.nio.charset.StandardCharsets;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

/**
 * @author yq
 * @date 2021/8/23 13:51
 */
@Slf4j
@RestController
public class TestController {


    @Autowired
    private RabbitTemplate personRabbitTemplate;

    @Autowired
    @Qualifier("cartRabbitTemplate")
    private RabbitTemplate cartRabbitTemplate;

    @Autowired
    @Qualifier("chargeRabbitTemplate")
    private RabbitTemplate chargeRabbitTemplate;

    @Autowired
    @Qualifier("dishRabbitTemplate")
    private RabbitTemplate dishRabbitTemplate;
    @GetMapping("/personTest")
    public String sendDirectMessage() {
        String messageId = String.valueOf(UUID.randomUUID());
        String messageData = "test message, hello!";
        String createTime = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        Map<String,Object> map=new HashMap<>();
        map.put("messageId",messageId);
        map.put("messageData",messageData);
        map.put("createTime",createTime);
        //将消息携带绑定键值：TestDirectRouting 发送到交换机TestDirectExchange
        personRabbitTemplate.convertAndSend(RabbitmqConfig.PERSON, RabbitmqConfig.PERSON, map);
        return "ok";
    }

    @GetMapping("/cartTest")
    public String sendDirectMessageCard() {
        String messageId = String.valueOf(UUID.randomUUID());
        String messageData = "test message, hello!";
        String createTime = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
        Map<String,Object> map=new HashMap<>();
        map.put("messageId",messageId);
        map.put("messageData",messageData);
        map.put("createTime",createTime);
        //将消息携带绑定键值：TestDirectRouting 发送到交换机TestDirectExchange
        cartRabbitTemplate.convertAndSend(RabbitmqConfig.CARD, RabbitmqConfig.CARD, map);
        return "ok";
    }


    @GetMapping("/chargeTest")
    public String sendDirectMessageCharge() {
        Map<String,Object> map = new HashMap<>();
        map.put("seq",1);
        map.put("create_date",new Date());
        map.put("card",1);
        map.put("card_no",1);
        map.put("type",1);
        map.put("term",1);
        map.put("shop",1);
        map.put("term_name",1);
        map.put("shop_name",1);
        map.put("amt",1);
        map.put("balance",1);
        map.put("account",1);
        chargeRabbitTemplate.convertAndSend(RabbitmqConfig.CHARGE, RabbitmqConfig.CHARGE, map);
        return "ok";
    }


    @GetMapping("/dishTest")
    public String sendDirectMessageDish() {
        Map<String,Object> map = new HashMap<>();
        map.put("seq",1);
        map.put("create_date",new Date());
        map.put("card",1);
        map.put("card_no",1);
        map.put("type",1);
        map.put("term",1);
        map.put("shop",1);
        map.put("term_name",1);
        map.put("shop_name",1);
        map.put("amt",1);
        map.put("balance",1);
        map.put("account",1);
        Map<String,Object> details = new HashMap<>();
        details.put("pid",1);
        details.put("name",1);
        details.put("price",1);
        details.put("amt",1);
        map.put("details",details);
        Map<String,Object> payments = new HashMap<>();
        payments.put("type",1);
        payments.put("amt",1);
        payments.put("balance",1);
        map.put("payments",payments);
        dishRabbitTemplate.convertAndSend(RabbitmqConfig.DISH, RabbitmqConfig.DISH, map);
        return "ok";
    }

}
